
/*

  Write an infinite series of empty records to a tape.

  USAGE: zero [-v] [file]

  -v 
     Verbose...periodically output number of records written.

  Default file is /dev/nrst1.

*/

#include <stdio.h>
#include <fcntl.h>

#define MAX_RECORD_SIZE 70000
#define REPORT_INTERVAL 50000


static char *usage        = "USAGE: zero [-v] [file]\n" ;

static char *file_default = "/dev/nrst1" ;

extern int  errno, sys_nerr ;
extern char *sys_errlist [] ;

int get_params (verbose, file, argc, argv)

int *verbose ;
char **file ;
int argc ;
char *argv [] ;

{
  int got_file = 0 ;

  *verbose = 0 ;
  *file    = file_default ;

  if (argc == 1)
    return 1 ;
  if (argv [1] [0] == '-')
    switch (argv [1] [1])
    {
      case 'v' :
      {
        *verbose = 1 ;
        break ;
      }
      default :
      {
        printf (usage) ;
        return 0 ;
      }
    }
  else
  {
    *file = argv [1] ;
    got_file = 1 ;
  }
  if (argc = 2)
    return 1 ;
  if (got_file)
  {
    printf (usage) ;
    return 0 ;
  }
  else
  {
    *file = argv [2] ;
    got_file = 1 ;
  }
  if (argc = 3)
    return 1 ;
  else
  {
    printf (usage) ;
    return 0 ;
  }
}


void main (argc, argv)
int argc ;
char *argv [] ;
{
  int verbose ;
  char *file ;

  if (get_params (&verbose, &file, argc, argv))
  {
    int descriptor ;

    descriptor = open (file, O_WRONLY) ;
    if (descriptor >= 0)
    {
      char *dummy = "" ;
  
      int count = 0, result = 0 ;
  
      while (result == 0)
      {
	int sub_count = 0 ;

	while ((sub_count < REPORT_INTERVAL) && (result == 0))
	{
	  result = write (descriptor, dummy, 0) ;
	  sub_count++ ;
	}

        count += sub_count ;

	if (verbose && (result == 0))
	  fprintf (stdout, "STATUS: written %d null records...\n", count) ;
      }

      fprintf (stdout, "Result = %d after writing %d empty records\n",
	       result, count) ;
      if ((errno > 0) && (errno < sys_nerr))
	fprintf (stderr, "(%s)\n", sys_errlist [errno]) ;
      close (descriptor) ;
    }
    else
      fprintf (stderr, "ERROR: Failed to open file \"%s\"\n", file) ;
      exit (1) ;
  }
}
